## luminance-hdr 2.6.1.1+dfsg

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.3)
CMAKE_POLICY(SET CMP0025 NEW)
CMAKE_POLICY(SET CMP0043 NEW)
CMAKE_POLICY(SET CMP0054 NEW)
CMAKE_POLICY(SET CMP0053 NEW)
PROJECT("Luminance HDR")

string(TOLOWER ${CMAKE_BUILD_TYPE} LOWERCASE_CMAKE_BUILD_TYPE)
if(LOWERCASE_CMAKE_BUILD_TYPE MATCHES "^(debug|release|relwithdebinfo|minsizerel)$")
    message(STATUS "CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}")
else()
    message(FATAL_ERROR "Invalid value for CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}\n"
        "CMAKE_BUILD_TYPE should be one of:\nDebug, Release, RelWithDebInfo, MinSizeRel")
endif()

if(LOWERCASE_CMAKE_BUILD_TYPE MATCHES "^(release|minsizerel)$")
    message(STATUS "Adding definitions: -DQT_NO_DEBUG_OUTPUT")
    add_definitions("-DQT_NO_DEBUG_OUTPUT")
endif()

# assume built-in pthreads on MacOS
IF(APPLE)
    enable_language(CXX)
    enable_language(C)
    set(CMAKE_THREAD_LIBS_INIT "-lpthread")
    set(CMAKE_HAVE_THREADS_LIBRARY 1)
    set(CMAKE_USE_WIN32_THREADS_INIT 0)
    set(CMAKE_USE_PTHREADS_INIT 1)
    set(THREADS_PREFER_PTHREAD_FLAG ON)
ENDIF()

# set include path for FindXXX.cmake files
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/build_files/Modules")

# Global variables for CMake
include(build_files/Modules/Version.cmake)
include(build_files/Modules/GlobalSettings.cmake)
include(build_files/Modules/CompilerSettings.cmake)
include(build_files/Modules/Internationalization.cmake)

IF(TIMER_PROFILING)
    ADD_DEFINITIONS(-DTIMER_PROFILING)
ENDIF()

# ======== Enable GNU gsl inline code =======
IF(UNIX OR APPLE OR MINGW) # Visual Studio doesn't like this
    ADD_DEFINITIONS(-DHAVE_INLINE )
ENDIF()

# ======== Has branch prediction =======
include( CheckCXXSourceCompiles )

check_cxx_source_compiles( "int main() { int x = 0; if( __builtin_expect((x),0) ) x = 1; return 0; }" HAS_BRANCH_PREDICTION )

if( HAS_BRANCH_PREDICTION )
    set( BRANCH_PREDICTION 1 )
else( HAS_BRANCH_PREDICTION )
    set( BRANCH_PREDICTION 0 )
endif( HAS_BRANCH_PREDICTION )

# find and setup Qt5 for this project

find_package(Qt5Core             REQUIRED)
find_package(Qt5Concurrent       REQUIRED)
find_package(Qt5Widgets          REQUIRED)
find_package(Qt5Gui              REQUIRED)
# QtWebEngine is preferred web engine because QtWebKit is deprecated since Qt 5.5:
# https://wiki.qt.io/New-Features-in-Qt-5.5#Deprecated_Functionality. Unfortunately,
# some Qt distributions still provide QtWebKit instead of QtWebEngine. So first we
# try to find QtWebEngine and if not found, we fall back to QtWebKit.
find_package(Qt5WebEngineCore    QUIET)
if(Qt5WebEngineCore_FOUND)
    find_package(Qt5WebEngineWidgets REQUIRED)
else()
    find_package(Qt5WebKit           REQUIRED)
    find_package(Qt5WebKitWidgets    REQUIRED)
    add_definitions(-DUSE_DEPRECATED_QTWEBKIT)
endif()
find_package(Qt5Xml              REQUIRED)
find_package(Qt5Sql              REQUIRED)
find_package(Qt5Svg              REQUIRED)
find_package(Qt5Network          REQUIRED)
find_package(Qt5LinguistTools    REQUIRED)
find_package(Qt5PrintSupport     REQUIRED)
IF(WIN32)
    find_package(Qt5WinExtras)
ENDIF()

# Include the qtmain lib if we are on the windows platform
IF(WIN32)
    SET(LIBS ${LIBS} ${Qt5Core_QTMAIN_LIBRARIES})
ENDIF(WIN32)

set(LIBS ${LIBS}
    ${QT_QTCORE_LIBRARIES}  ${QT_QTGUI_LIBRARIES}  ${QT_QTNETWORK_LIBRARIES}
    ${QT_QTXML_LIBRARIES}   ${QT_QTSQL_LIBRARIES})

if(Qt5WebEngineCore_FOUND)
    message(STATUS "Building with QtWebEngine")
    set(LIBS ${LIBS} ${QT_QTWEBENGINE_LIBRARIES})
else()
    message(STATUS "Building with QtWebKit")
    set(LIBS ${LIBS} ${QT_QTWEBKIT_LIBRARIES})
endif()

FIND_PACKAGE(Git)
IF(GIT_FOUND)
    include(GetGitRevisionDescription)
    get_git_head_revision(GIT_REFSPEC GIT_SHA1)
ENDIF()

IF(WIN32)

    # Windows Section

    # to not define min/max macros, which cause troubles with STL and boost
    ADD_DEFINITIONS(-DNOMINMAX)
    IF(MINGW)
        find_package(PkgConfig)
        pkg_check_modules(FFTW3F REQUIRED fftw3f)
        SET(FFTWF_LIBRARIES "libfftw3f.a")
        pkg_check_modules(LCMS REQUIRED lcms2>=2.6)
        pkg_check_modules(LibRAW REQUIRED libraw)
        ADD_DEFINITIONS("-DDEMOSAICING_GPL2")
        ADD_DEFINITIONS("-DDEMOSAICING_GPL3")
        find_package(OpenMP)
        IF(OPENMP_FOUND)
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS} -Werror=unknown-pragmas")
        ENDIF()
        FIND_PACKAGE(Eigen3 REQUIRED)
        INCLUDE_DIRECTORIES(${EIGEN3_INCLUDE_DIR})
    ELSE()
        SET(LibRAW_INCLUDE_DIR "${CMAKE_SOURCE_DIR}/../DEPs/include/libraw")
        SET(FFTWF_INCLUDE_DIR "${CMAKE_SOURCE_DIR}/../DEPs/include/fftw3")
        SET(LCMS2_INCLUDE_DIR "${CMAKE_SOURCE_DIR}/../DEPs/include/lcms2")

        # Enable multi processor compilation
        ADD_DEFINITIONS(/MP)

        # Enable SSE2
        IF(CMAKE_SIZEOF_VOID_P EQUAL 4)
            # SSE2 is on by default, on x64 platforms
            ADD_DEFINITIONS(/arch:SSE2)
        ENDIF()

        ADD_DEFINITIONS(-DUNICODE )
        ADD_DEFINITIONS(-D_CRT_SECURE_NO_WARNINGS -D_REENTRANT)

        SET(LibRAW_LIBRARIES "${CMAKE_SOURCE_DIR}/../DEPs/lib/libraw/libraw.lib")
        ADD_DEFINITIONS("-DDEMOSAICING_GPL2")
        ADD_DEFINITIONS("-DDEMOSAICING_GPL3")

        SET(LCMS2_LIBRARIES "${CMAKE_SOURCE_DIR}/../DEPs/lib/lcms2/lcms2.lib")
        ADD_DEFINITIONS(-DCMS_DLL)
        ADD_DEFINITIONS(-DUSE_LCMS2)

        INCLUDE_DIRECTORIES(${LibRAW_INCLUDE_DIR} "${LibRAW_INCLUDE_DIR}/libraw")
        INCLUDE_DIRECTORIES(${FFTWF_INCLUDE_DIR})
        INCLUDE_DIRECTORIES(${LCMS2_INCLUDE_DIR})
    ENDIF()
ELSE()
    # Unix & Apple part
    FIND_PACKAGE(LibRAW REQUIRED)
    INCLUDE_DIRECTORIES(${LibRAW_INCLUDE_DIR} "${LibRAW_INCLUDE_DIR}/libraw")

    FIND_PACKAGE(fftwf REQUIRED)
    INCLUDE_DIRECTORIES(${FFTWF_INCLUDE_DIR})

    FIND_PACKAGE(lcms2 REQUIRED)
    INCLUDE_DIRECTORIES(${LCMS2_INCLUDE_DIR})

    FIND_PACKAGE(Eigen3 REQUIRED)
    INCLUDE_DIRECTORIES(${EIGEN3_INCLUDE_DIR})
ENDIF()

IF(WIN32)
    SET(Boost_USE_STATIC_LIBS ON)
ENDIF()
FIND_PACKAGE(Boost REQUIRED COMPONENTS program_options thread chrono system date_time)
INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIR})

FIND_PACKAGE(Exiv2 REQUIRED)
INCLUDE_DIRECTORIES(${EXIV2_INCLUDE_DIR} "${EXIV2_INCLUDE_DIR}/exiv2")

FIND_PACKAGE(TIFF REQUIRED)
INCLUDE_DIRECTORIES(${TIFF_INCLUDE_DIR})

FIND_PACKAGE(PNG REQUIRED)
INCLUDE_DIRECTORIES(${PNG_INCLUDE_DIR})

FIND_PACKAGE(OpenEXR REQUIRED)
INCLUDE_DIRECTORIES(${OPENEXR_INCLUDE_DIR} "${OPENEXR_INCLUDE_DIR}/OpenEXR")

FIND_PACKAGE(GSL REQUIRED)
INCLUDE_DIRECTORIES(${GSL_INCLUDE_DIR} ${GSLCBLAS_INCLUDE_DIR})

FIND_PACKAGE(JPEG REQUIRED)
INCLUDE_DIRECTORIES(${JPEGLIB_INCLUDE_DIR})

FIND_PACKAGE(CFITSIO)
IF(CFITSIO_FOUND)
    INCLUDE_DIRECTORIES(${CFITSIO_INCLUDE_DIR})
    SET(LIBS ${LIBS} ${CFITSIO_LIBRARIES})
    ADD_DEFINITIONS(-DHAVE_CFITSIO)
ELSE()
    MESSAGE(WARNING "cfitsio not found! Building without FITS support!")
ENDIF()

SET(LIBS ${LIBS} ${OPENEXR_LIBRARIES})
SET(LIBS ${LIBS} ${TIFF_LIBRARIES})
SET(LIBS ${LIBS} ${LibRAW_LIBRARIES})
SET(LIBS ${LIBS} ${FFTWF_LIBRARIES})
ADD_DEFINITIONS(-DHAVE_FFTW3F)
SET(LIBS ${LIBS} ${GSL_LIBRARIES} ${GSLCBLAS_LIBRARIES})
SET(LIBS ${LIBS} ${EXIV2_LIBRARIES})
SET(LIBS ${LIBS} ${JPEG_LIBRARIES})
SET(LIBS ${LIBS} ${LCMS2_LIBRARIES})
SET(LIBS ${LIBS} ${PNG_LIBRARIES})
SET(LIBS ${LIBS} ${Boost_LIBRARIES})

INCLUDE_DIRECTORIES("${CMAKE_SOURCE_DIR}/src/")
INCLUDE_DIRECTORIES("${CMAKE_BINARY_DIR}/src/")
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})

SET(LUMINANCE_HDR_H )
SET(LUMINANCE_HDR_SRC )

SET(LUMINANCE_HDR_H ${LUMINANCE_HDR_H}
    src/arch/math.h
    src/arch/malloc.h
    src/arch/string.h
    src/arch/freebsd/math.h
    src/arch/msvc/math.h
)

SET(LUMINANCE_HDR_RCCS icons.qrc)
QT5_ADD_RESOURCES(LUMINANCE_HDR_RCCS_SRCS ${LUMINANCE_HDR_RCCS})

ADD_SUBDIRECTORY(src)

IF(ENABLE_UNIT_TEST)
    ENABLE_TESTING()
    ADD_SUBDIRECTORY(test)
ENDIF(ENABLE_UNIT_TEST)

# translations
FILE(GLOB LUMINANCE_TS i18n/lang_*.ts)

IF(UPDATE_TRANSLATIONS)
    SET(LUMINANCE_TS ${LUMINANCE_TS} i18n/source.ts)
    IF(LUPDATE_NOOBSOLETE)
        QT5_CREATE_TRANSLATION(LUMINANCE_QM ${FILES_TO_TRANSLATE} ${LUMINANCE_TS} OPTIONS -noobsolete)
    ELSE()
        QT5_CREATE_TRANSLATION(LUMINANCE_QM ${FILES_TO_TRANSLATE} ${LUMINANCE_TS})
    ENDIF()
    IF(UNIX)
        IF(NOT APPLE) # Sadly on Linux Qt5 add global include paths in list of translation files, let's get rid of them
            EXECUTE_PROCESS(COMMAND ${CMAKE_SOURCE_DIR}/build_files/platforms/linux/sanitize_translations.sh
                WORKING_DIRECTORY ${CMAKE_BINARY_DIR})
        ENDIF(NOT APPLE)
    ENDIF(UNIX)
ELSE(UPDATE_TRANSLATIONS)
    QT5_ADD_TRANSLATION(LUMINANCE_QM ${LUMINANCE_TS})
ENDIF(UPDATE_TRANSLATIONS)

ADD_CUSTOM_TARGET(translations_target DEPENDS ${LUMINANCE_QM})

SET(LUMINANCE_FILES
    ${LUMINANCE_HDR_H}
    ${LUMINANCE_HDR_CPP}
    ${LUMINANCE_HDR_RCCS_SRCS}
    ${LUMINANCE_QM})

# MacOSX
IF(APPLE)
    SET(CMAKE_INSTALL_PREFIX ".")

    # Set Bundle settings
    set(MACOSX_BUNDLE_INFO_STRING          "${LHDR_NAME} ${LHDR_VERSION}")
    set(MACOSX_BUNDLE_BUNDLE_VERSION       "${LHDR_NAME} ${LHDR_VERSION}")
    set(MACOSX_BUNDLE_LONG_VERSION_STRING  "${LHDR_NAME} ${LHDR_VERSION}")
    set(MACOSX_BUNDLE_SHORT_VERSION_STRING "${LHDR_VERSION}")
    set(MACOSX_BUNDLE_VERSION              "${LHDR_VERSION}")
    set(MACOSX_BUNDLE_ICON_FILE            "${CMAKE_SOURCE_DIR}/program-icons/luminance.icns")
    set(MACOSX_BUNDLE_ICON                 "${CMAKE_SOURCE_DIR}/program-icons/luminance.icns")
    set(MACOSX_BUNDLE_RESOURCES            "${CMAKE_CURRENT_BINARY_DIR}/${LHDR_OSX_EXECUTABLE_NAME}.app/Contents/Resources")
    set(MACOSX_BUNDLE_GUI_IDENTIFIER       "${LHDR_DOMAIN_SECOND}.${LHDR_DOMAIN_FIRST}")
    set(MACOSX_BUNDLE_BUNDLE_NAME          "${LHDR_NAME}")

    configure_file( ${CMAKE_SOURCE_DIR}/build_files/platforms/macosx/Info.plist.in
                    ${CMAKE_BINARY_DIR}/Info.plist )

    # icon files to copy in the bundle
    SET(OSX_ICON_FILES "${CMAKE_SOURCE_DIR}/program-icons/luminance.icns")
    # include the icns files in the target
    SET(LUMINANCE_FILES ${LUMINANCE_FILES} ${OSX_ICON_FILES})

    # Build project (bundle and luminance-hdr-cli)
    SET( CMAKE_OSX_ARCHITECTURES x86_64 )  # Universal/Generic x86_64 build
    ADD_EXECUTABLE(${LHDR_OSX_EXECUTABLE_TARGET} MACOSX_BUNDLE ${LUMINANCE_FILES})
    ADD_EXECUTABLE(luminance-hdr-cli ${LUMINANCE_FILES} )
    set_property(TARGET ${LHDR_OSX_EXECUTABLE_TARGET} PROPERTY OUTPUT_NAME ${LHDR_OSX_EXECUTABLE_NAME})
    set_property(TARGET   luminance-hdr-cli           PROPERTY RUNTIME_OUTPUT_DIRECTORY ${LHDR_OSX_EXECUTABLE_NAME}.app/Contents/MacOS)

    # Mac bundle magic
    SET_TARGET_PROPERTIES( ${LHDR_OSX_EXECUTABLE_TARGET} PROPERTIES MACOSX_BUNDLE_INFO_PLIST
                           "${CMAKE_BINARY_DIR}/Info.plist" )

    # set where in the bundle to put the icns files
    SET_SOURCE_FILES_PROPERTIES(${OSX_ICON_FILES}  PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
    # set where in the bundle to put the translation files
    SET_SOURCE_FILES_PROPERTIES(${LUMINANCE_QM}    PROPERTIES MACOSX_PACKAGE_LOCATION Resources/i18n)
    SET_SOURCE_FILES_PROPERTIES(${LUMINANCE_QT_QM} PROPERTIES MACOSX_PACKAGE_LOCATION Resources/i18n)

    # QT magic
    TARGET_LINK_LIBRARIES(${LHDR_OSX_EXECUTABLE_TARGET} Qt5::Core Qt5::Gui Qt5::Widgets)
    TARGET_LINK_LIBRARIES(luminance-hdr-cli Qt5::Core Qt5::Gui Qt5::Widgets)

    # Link libraries
    TARGET_LINK_LIBRARIES(${LHDR_OSX_EXECUTABLE_TARGET} ${LUMINANCE_MODULES_GUI} ${LIBS})
    TARGET_LINK_LIBRARIES(luminance-hdr-cli             ${LUMINANCE_MODULES_CLI} ${LIBS})

    # Rename generated executable binary to luminance-hdr
    add_custom_command(
    TARGET ${LHDR_OSX_EXECUTABLE_TARGET}
    POST_BUILD
    COMMAND mv ${LHDR_OSX_EXECUTABLE_NAME}.app/Contents/MacOS/${LHDR_OSX_EXECUTABLE_NAME} ${LHDR_OSX_EXECUTABLE_NAME}.app/Contents/MacOS/luminance-hdr
    )

=== src/BatchHDR/CMakeLists.txt ===
SET(FILES_UI
${CMAKE_CURRENT_SOURCE_DIR}/BatchHDRDialog.ui)
SET(FILES_H
${CMAKE_CURRENT_SOURCE_DIR}/BatchHDRDialog.h)
SET(FILES_CPP
${CMAKE_CURRENT_SOURCE_DIR}/BatchHDRDialog.cpp)

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})

QT5_WRAP_CPP(FILES_MOC ${FILES_H})
QT5_WRAP_UI(FILES_UI_H ${FILES_UI})

ADD_LIBRARY(batchhdr STATIC ${FILES_H} ${FILES_CPP} ${FILES_MOC} ${FILES_UI_H})
TARGET_LINK_LIBRARIES(batchhdr Qt5::Concurrent Qt5::Core Qt5::Gui Qt5::Widgets Qt5::Sql Qt5::Xml)

SET(FILES_TO_TRANSLATE ${FILES_TO_TRANSLATE} ${FILES_CPP} ${FILES_H} ${FILES_UI} PARENT_SCOPE)
SET(LUMINANCE_MODULES_GUI ${LUMINANCE_MODULES_GUI} batchhdr PARENT_SCOPE)

=== src/BatchTM/CMakeLists.txt ===
SET(FILES_UI
${CMAKE_CURRENT_SOURCE_DIR}/BatchTMDialog.ui)
SET(FILES_H
${CMAKE_CURRENT_SOURCE_DIR}/BatchTMDialog.h
${CMAKE_CURRENT_SOURCE_DIR}/BatchTMJob.h)
SET(FILES_CPP
${CMAKE_CURRENT_SOURCE_DIR}/BatchTMDialog.cpp
${CMAKE_CURRENT_SOURCE_DIR}/BatchTMJob.cpp)

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})

QT5_WRAP_CPP(FILES_MOC ${FILES_H})
QT5_WRAP_UI(FILES_UI_H ${FILES_UI})

ADD_LIBRARY(batchtm STATIC ${FILES_H} ${FILES_CPP} ${FILES_MOC} ${FILES_UI_H})
TARGET_LINK_LIBRARIES(batchtm Qt5::Core Qt5::Gui Qt5::Widgets Qt5::Sql Qt5::Xml)

SET(FILES_TO_TRANSLATE ${FILES_TO_TRANSLATE} ${FILES_CPP} ${FILES_H} ${FILES_UI} PARENT_SCOPE)
SET(LUMINANCE_MODULES_GUI ${LUMINANCE_MODULES_GUI} batchtm PARENT_SCOPE)

=== src/Exif/CMakeLists.txt ===
#SET(FILES_UI )
SET(FILES_H )
SET(FILES_HXX
${CMAKE_CURRENT_SOURCE_DIR}/ExifOperations.h)
SET(FILES_CPP
${CMAKE_CURRENT_SOURCE_DIR}/ExifOperations.cpp)

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})

QT5_WRAP_CPP(FILES_MOC ${FILES_H})
# QT5_WRAP_UI(FILES_UI_H ${FILES_UI})

ADD_LIBRARY(exif STATIC ${FILES_H} ${FILES_CPP} ${FILES_MOC} ${FILES_HXX}) # ${FILES_UI_H}
TARGET_LINK_LIBRARIES(exif Qt5::Core)

SET(FILES_TO_TRANSLATE ${FILES_TO_TRANSLATE} ${FILES_CPP} ${FILES_H} ${FILES_HXX} PARENT_SCOPE) # ${FILES_UI}
SET(LUMINANCE_MODULES_GUI ${LUMINANCE_MODULES_GUI} exif PARENT_SCOPE)
SET(LUMINANCE_MODULES_CLI ${LUMINANCE_MODULES_CLI} exif PARENT_SCOPE)

=== src/HdrHTML/CMakeLists.txt ===
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/hdrhtml-path.hxx.in
    ${CMAKE_CURRENT_BINARY_DIR}/hdrhtml-path.hxx @ONLY)

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})

SET(FILES_H
${CMAKE_CURRENT_SOURCE_DIR}/hdrhtml.h)

SET(FILES_CPP
${CMAKE_CURRENT_SOURCE_DIR}/hdrhtml.cpp
${CMAKE_CURRENT_SOURCE_DIR}/pfsouthdrhtml.cpp)

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})

ADD_LIBRARY(hdrhtml STATIC ${FILES_H} ${FILES_CPP})
TARGET_LINK_LIBRARIES(hdrhtml Qt5::Core Qt5::Gui)

SET(FILES_CLI_H
${CMAKE_CURRENT_SOURCE_DIR}/hdrhtml.h)

SET(FILES_CLI_CPP
${CMAKE_CURRENT_SOURCE_DIR}/hdrhtml.cpp
${CMAKE_CURRENT_SOURCE_DIR}/pfsouthdrhtml.cpp)

ADD_LIBRARY(hdrhtml-cli STATIC ${FILES_CLI_H} ${FILES_CLI_CPP})
TARGET_LINK_LIBRARIES(hdrhtml-cli Qt5::Core Qt5::Gui)

SET(FILES_TO_TRANSLATE ${FILES_TO_TRANSLATE}
    ${FILES_CPP} ${FILES_H}
    ${FILES_CLI_CPP} ${FILES_CLI_H}
    PARENT_SCOPE)

SET(LUMINANCE_MODULES_GUI ${LUMINANCE_MODULES_GUI} hdrhtml  PARENT_SCOPE)
SET(LUMINANCE_MODULES_CLI ${LUMINANCE_MODULES_CLI} hdrhtml-cli PARENT_SCOPE)

=== src/HelpBrowser/CMakeLists.txt ===
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/help-path.hxx.in
    ${CMAKE_CURRENT_BINARY_DIR}/help-path.hxx @ONLY)

SET(FILES_UI
${CMAKE_CURRENT_SOURCE_DIR}/HelpBrowser.ui
${CMAKE_CURRENT_SOURCE_DIR}/HelpSideBar.ui)
SET(FILES_H # to go into MOC
${CMAKE_CURRENT_SOURCE_DIR}/helpbrowser.h
${CMAKE_CURRENT_SOURCE_DIR}/HelpSideBar.h
${CMAKE_CURRENT_SOURCE_DIR}/sctextbrowser.h)
SET(FILES_HXX # NOT to go into MOC
${CMAKE_CURRENT_SOURCE_DIR}/LuminancePaths.h
${CMAKE_CURRENT_SOURCE_DIR}/schelptreemodel.h
${CMAKE_CURRENT_SOURCE_DIR}/treeitem.h
${CMAKE_CURRENT_SOURCE_DIR}/treemodel.h)
SET(FILES_CPP
${CMAKE_CURRENT_SOURCE_DIR}/helpbrowser.cpp
${CMAKE_CURRENT_SOURCE_DIR}/HelpSideBar.cpp
${CMAKE_CURRENT_SOURCE_DIR}/LuminancePaths.cpp
${CMAKE_CURRENT_SOURCE_DIR}/schelptreemodel.cpp
${CMAKE_CURRENT_SOURCE_DIR}/sctextbrowser.cpp
${CMAKE_CURRENT_SOURCE_DIR}/treeitem.cpp
${CMAKE_CURRENT_SOURCE_DIR}/treemodel.cpp)

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})

QT5_WRAP_CPP(FILES_MOC ${FILES_H})
QT5_WRAP_UI(FILES_UI_H ${FILES_UI})

ADD_LIBRARY(helpbrowser STATIC ${FILES_H} ${FILES_CPP} ${FILES_MOC} ${FILES_UI_H} ${FILES_HXX})
IF(Qt5WebEngineCore_FOUND)
    TARGET_LINK_LIBRARIES(helpbrowser Qt5::Core Qt5::Concurrent Qt5::Gui Qt5::Widgets Qt5::Xml Qt5::WebEngineCore Qt5::WebEngineWidgets Qt5::PrintSupport)
ELSE()
    TARGET_LINK_LIBRARIES(helpbrowser Qt5::Core Qt5::Concurrent Qt5::Gui Qt5::Widgets Qt5::Xml Qt5::WebKit Qt5::WebKitWidgets Qt5::PrintSupport)
ENDIF()

SET(FILES_TO_TRANSLATE ${FILES_TO_TRANSLATE} ${FILES_CPP} ${FILES_H} ${FILES_UI} ${FILES_HXX} PARENT_SCOPE)
SET(LUMINANCE_MODULES_GUI ${LUMINANCE_MODULES_GUI} helpbrowser PARENT_SCOPE)

=== src/Preferences/CMakeLists.txt ===
SET(FILES_UI
${CMAKE_CURRENT_SOURCE_DIR}/PreferencesDialog.ui)
SET(FILES_H
${CMAKE_CURRENT_SOURCE_DIR}/PreferencesDialog.h)
SET(FILES_CPP
${CMAKE_CURRENT_SOURCE_DIR}/PreferencesDialog.cpp)

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})

QT5_WRAP_CPP(FILES_MOC ${FILES_H})
QT5_WRAP_UI(FILES_UI_H ${FILES_UI})

ADD_LIBRARY(preferencesdialog STATIC ${FILES_H} ${FILES_CPP} ${FILES_MOC} ${FILES_UI_H})
TARGET_LINK_LIBRARIES(preferencesdialog Qt5::Core Qt5::Gui Qt5::Widgets)

SET(FILES_TO_TRANSLATE ${FILES_TO_TRANSLATE} ${FILES_CPP} ${FILES_H} ${FILES_UI} PARENT_SCOPE)
SET(LUMINANCE_MODULES_GUI ${LUMINANCE_MODULES_GUI} preferencesdialog PARENT_SCOPE)

=== src/PreviewSettings/CMakeLists.txt ===
SET(FILES_H
${CMAKE_CURRENT_SOURCE_DIR}/PreviewSettings.h)
SET(FILES_CPP
${CMAKE_CURRENT_SOURCE_DIR}/PreviewSettings.cpp)

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})

QT5_WRAP_CPP(FILES_MOC ${FILES_H})

ADD_LIBRARY(previewsettings STATIC ${FILES_H} ${FILES_CPP} ${FILES_MOC})
TARGET_LINK_LIBRARIES(previewsettings Qt5::Core Qt5::Concurrent Qt5::Gui Qt5::Widgets)

SET(FILES_TO_TRANSLATE ${FILES_TO_TRANSLATE} ${FILES_CPP} ${FILES_H} ${FILES_UI} PARENT_SCOPE)
SET(LUMINANCE_MODULES_GUI ${LUMINANCE_MODULES_GUI} previewsettings PARENT_SCOPE)

=== src/Resize/CMakeLists.txt ===
SET(FILES_UI
${CMAKE_CURRENT_SOURCE_DIR}/ResizeDialog.ui)
SET(FILES_H
${CMAKE_CURRENT_SOURCE_DIR}/ResizeDialog.h)
SET(FILES_CPP
${CMAKE_CURRENT_SOURCE_DIR}/ResizeDialog.cpp)

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})

QT5_WRAP_CPP(FILES_MOC ${FILES_H})
QT5_WRAP_UI(FILES_UI_H ${FILES_UI})

ADD_LIBRARY(resizedialog STATIC ${FILES_H} ${FILES_CPP} ${FILES_MOC} ${FILES_UI_H})
TARGET_LINK_LIBRARIES(resizedialog Qt5::Core Qt5::Gui Qt5::Widgets)

SET(FILES_TO_TRANSLATE ${FILES_TO_TRANSLATE} ${FILES_CPP} ${FILES_H} ${FILES_UI} PARENT_SCOPE)
SET(LUMINANCE_MODULES_GUI ${LUMINANCE_MODULES_GUI} resizedialog PARENT_SCOPE)

=== src/TonemappingPanel/CMakeLists.txt ===
SET(FILES_UI
${CMAKE_CURRENT_SOURCE_DIR}/SavingParametersDialog.ui
${CMAKE_CURRENT_SOURCE_DIR}/TonemappingPanel.ui
${CMAKE_CURRENT_SOURCE_DIR}/TonemappingSettings.ui
${CMAKE_CURRENT_SOURCE_DIR}/ThresholdWidget.ui
)
SET(FILES_H
${CMAKE_CURRENT_SOURCE_DIR}/SavingParametersDialog.h
${CMAKE_CURRENT_SOURCE_DIR}/TMOProgressIndicator.h
${CMAKE_CURRENT_SOURCE_DIR}/TonemappingPanel.h
${CMAKE_CURRENT_SOURCE_DIR}/TonemappingSettings.h
${CMAKE_CURRENT_SOURCE_DIR}/ThresholdWidget.h
)
SET(FILES_CPP
${CMAKE_CURRENT_SOURCE_DIR}/SavingParametersDialog.cpp
${CMAKE_CURRENT_SOURCE_DIR}/TMOProgressIndicator.cpp
${CMAKE_CURRENT_SOURCE_DIR}/TonemappingPanel.cpp
${CMAKE_CURRENT_SOURCE_DIR}/TonemappingSettings.cpp
${CMAKE_CURRENT_SOURCE_DIR}/ThresholdWidget.cpp
)

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})

QT5_WRAP_CPP(FILES_MOC ${FILES_H})
QT5_WRAP_UI(FILES_UI_H ${FILES_UI})

ADD_LIBRARY(tonemappingpanel STATIC ${FILES_H} ${FILES_CPP} ${FILES_MOC} ${FILES_UI_H})
TARGET_LINK_LIBRARIES(tonemappingpanel Qt5::Core Qt5::Gui Qt5::Widgets Qt5::Sql Qt5::Xml)

SET(FILES_TO_TRANSLATE ${FILES_TO_TRANSLATE} ${FILES_CPP} ${FILES_H} ${FILES_UI} PARENT_SCOPE)
SET(LUMINANCE_MODULES_GUI ${LUMINANCE_MODULES_GUI} tonemappingpanel PARENT_SCOPE)

=== src/UI/CMakeLists.txt ===
SET(FILES_UI
    ${CMAKE_CURRENT_SOURCE_DIR}/GammaAndLevels.ui
    ${CMAKE_CURRENT_SOURCE_DIR}/ImageQualityDialog.ui
    ${CMAKE_CURRENT_SOURCE_DIR}/TiffModeDialog.ui
    ${CMAKE_CURRENT_SOURCE_DIR}/about.ui
    ${CMAKE_CURRENT_SOURCE_DIR}/ExportToHtmlDialog.ui
    ${CMAKE_CURRENT_SOURCE_DIR}/SupportedCamerasDialog.ui
    ${CMAKE_CURRENT_SOURCE_DIR}/SavedParametersDialog.ui
)
SET(FILES_H
    ${CMAKE_CURRENT_SOURCE_DIR}/ExtWizardPage.h
    ${CMAKE_CURRENT_SOURCE_DIR}/GammaAndLevels.h
    ${CMAKE_CURRENT_SOURCE_DIR}/Gang.h
    ${CMAKE_CURRENT_SOURCE_DIR}/ImageQualityDialog.h
    ${CMAKE_CURRENT_SOURCE_DIR}/TiffModeDialog.h
    ${CMAKE_CURRENT_SOURCE_DIR}/PreviewFrame.h
    ${CMAKE_CURRENT_SOURCE_DIR}/SimplePreviewLabel.h
    ${CMAKE_CURRENT_SOURCE_DIR}/UMessageBox.h
    ${CMAKE_CURRENT_SOURCE_DIR}/FlowLayout.h
    ${CMAKE_CURRENT_SOURCE_DIR}/ExportToHtmlDialog.h
    ${CMAKE_CURRENT_SOURCE_DIR}/SupportedCamerasDialog.h
    ${CMAKE_CURRENT_SOURCE_DIR}/SavedParametersDialog.h
)
SET(FILES_CPP
    ${CMAKE_CURRENT_SOURCE_DIR}/ExtWizardPage.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/GammaAndLevels.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/Gang.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/UMessageBox.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/FlowLayout.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ImageQualityDialog.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/TiffModeDialog.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/PreviewFrame.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/SimplePreviewLabel.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ExportToHtmlDialog.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/SupportedCamerasDialog.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/SavedParametersDialog.cpp
)

IF(CFITSIO_FOUND)
    SET(FILES_UI ${FILES_UI} ${CMAKE_CURRENT_SOURCE_DIR}/FitsImporter.ui)
    SET(FILES_H ${FILES_H} ${CMAKE_CURRENT_SOURCE_DIR}/FitsImporter.h)
    SET(FILES_CPP ${FILES_CPP} ${CMAKE_CURRENT_SOURCE_DIR}/FitsImporter.cpp)
ENDIF()    


INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})

QT5_WRAP_CPP(FILES_MOC ${FILES_H})
QT5_WRAP_UI(FILES_UI_H ${FILES_UI})

ADD_LIBRARY(ui STATIC ${FILES_H} ${FILES_CPP} ${FILES_MOC} ${FILES_UI_H})
IF(MINGW)
    TARGET_LINK_LIBRARIES(ui Qt5::Core Qt5::Concurrent Qt5::Gui Qt5::Widgets Qt5::WebKitWidgets Qt5::Sql)
ELSE()
    IF(Qt5WebEngineCore_FOUND)
        TARGET_LINK_LIBRARIES(ui Qt5::Core Qt5::Concurrent Qt5::Gui Qt5::Widgets Qt5::WebEngineWidgets Qt5::Sql)
    ELSE()
        TARGET_LINK_LIBRARIES(ui Qt5::Core Qt5::Concurrent Qt5::Gui Qt5::Widgets Qt5::WebKitWidgets Qt5::Sql)
    ENDIF()
ENDIF()
SET(FILES_TO_TRANSLATE ${FILES_TO_TRANSLATE} ${FILES_CPP} ${FILES_H} ${FILES_UI} PARENT_SCOPE)
SET(LUMINANCE_MODULES_GUI ${LUMINANCE_MODULES_GUI} ui PARENT_SCOPE)

=== src/Libpfs/io/CMakeLists.txt ===
FILE(GLOB IO_H *.h)
FILE(GLOB IO_HXX *.hxx)
FILE(GLOB IO_CPP *.cpp)

IF(NOT CFITSIO_FOUND)
    FILE(GLOB to_remove fitsreader.*)
    LIST(REMOVE_ITEM IO_CPP ${to_remove})
    LIST(REMOVE_ITEM IO_H ${to_remove})
ENDIF()

SET(LIBPFS_H ${LIBPFS_H} ${IO_H} ${IO_HXX} PARENT_SCOPE)
SET(LIBPFS_CPP ${LIBPFS_CPP} ${IO_CPP} PARENT_SCOPE)

=== debian/changelog ===
luminance-hdr (2.6.1.1+dfsg-5) unstable; urgency=medium

  * Apply patch from upstream issuetracker to fix FTBFS against boost >= 1.85
    and also bump C++ std version to 14 to allow building against boost 1.88.
    (Thanks, Matthias Klose) Closes: #1110597

 -- Andreas Metzler <ametzler@debian.org>  Mon, 11 Aug 2025 12:02:07 +0200

luminance-hdr (2.6.1.1+dfsg-4) unstable; urgency=medium

  * Team upload
  * Build with QtWebEngine instead of QtWebKit

 -- Bastian Germann <bage@debian.org>  Sun, 19 Jan 2025 18:05:06 +0100

luminance-hdr (2.6.1.1+dfsg-3) unstable; urgency=medium

  [ Pino Toscano ]
  * Backport upstream commit e5ebd48fac2de33f4990f530c68dd4c9d8fc3829 to build
    also against Exiv2 0.28+; patch 80_exiv2_0.28.diff
    - bump the libexiv2-dev build dependency to 0.27.0 accordingly

 -- Andreas Metzler <ametzler@debian.org>  Sun, 25 Feb 2024 14:09:41 +0100

luminance-hdr (2.6.1.1+dfsg-2) unstable; urgency=medium

  * 70_OpenEXR3.diff: Fix build error against OpenEXR 3. Closes: #1017526
  * Migrate lintian overrides with
    GIT/lintian/bin/lintian-migrate-overrides-to-pointed-hints.
  * Upload to unstable.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 20 Aug 2022 18:21:37 +0200

luminance-hdr (2.6.1.1+dfsg-1) experimental; urgency=medium

  * New upstream version.
  * Add lintian override for html templates.
  * Use dh v13 mode.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 03 Jul 2021 18:57:47 +0200

=== debian/control ===
Source: luminance-hdr
Section: graphics
Priority: optional
Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders:
 Andreas Metzler <ametzler@debian.org>,
 Leonardo Montecchi <lmontecchi@montex.org>,
Build-Depends:
 debhelper-compat (= 13),
 cmake (>= 2.8.11),
 libboost-chrono-dev,
 libboost-date-time-dev,
 libboost-dev,
 libboost-program-options-dev,
 libboost-system-dev,
 libboost-thread-dev,
 libccfits-dev,
 libeigen3-dev,
 libexiv2-dev (>= 0.27.0),
 libfftw3-dev,
 libgsl-dev,
 libjpeg-dev,
 liblcms2-dev,
 libopenexr-dev,
 libpng-dev,
 libqt5svg5-dev,
 libraw-dev,
 libtiff-dev,
 pkg-config,
 qtbase5-dev,
 qtdeclarative5-dev,
 qtscript5-dev,
 qttools5-dev (>= 5.2.1-7),
 qttools5-dev-tools,
 qtwebengine5-dev,
Rules-Requires-Root: no
Standards-Version: 4.5.1
Homepage: http://qtpfsgui.sourceforge.net/
Vcs-Browser: https://salsa.debian.org/debian-phototools-team/luminance-hdr
Vcs-Git: https://salsa.debian.org/debian-phototools-team/luminance-hdr.git

Package: luminance-hdr
Architecture: any
Built-Using:
 ${libeigen3-dev:Built-Using},
Depends:
 dcraw,
 hugin-tools,
 libqt5sql5-sqlite,
 ${misc:Depends},
 ${shlibs:Depends},
Description: graphical user interface providing a workflow for HDR imaging
 Features:
  * Create an HDR file from a set of images (formats: JPEG, TIFF 8bit and
    16bit, RAW) of the same scene taken at different exposure setting.
  * Save and load HDR images.
  * Rotate and resize HDR images.
  * Tonemap HDR images.
  * Copy exif data between sets of images.
 .
 Supported HDR formats:
  * OpenEXR (extension: exr).
  * Radiance RGBE (extension: hdr).
  * Tiff formats: 16bit, 32bit (float) and LogLuv (extension: tiff).
  * Raw image formats (extension: various).
  * PFS native format (extension: pfs).
 .
 Supported LDR formats: JPEG, PNG, PPM, PBM, TIFF (8 bit).

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed
export QT_SELECT := qt5

include /usr/share/dpkg/pkg-info.mk

# To enable test-suite build-depend on libgtest-dev and uncomment these lines
###override_dh_auto_configure:
###	cp -a /usr/src/gtest local-gtest && \
###		mkdir local-gtest/debian local-gtest/include && \
###		cp -a debian/compat debian/control local-gtest/debian && \
###		cd local-gtest && \
###		dh_auto_configure --verbose && \
###		dh_auto_build --verbose && \
###		ln -s /usr/include/gtest include/ && \
###		ln -s obj-* lib
###
###	dh_auto_configure --verbose -- -DGTEST_ROOT=$(CURDIR)/local-gtest

override_dh_auto_build:
	# Normal auto_build:
	dh_auto_build --verbose
	# Build the minimal manpage:
	pod2man --center='Minimal luminance-hdr manpage' \
		--release=$(DEB_VERSION_UPSTREAM) \
		debian/luminance-hdr.pod > debian/luminance-hdr.1

override_dh_auto_install:
	dh_auto_install --verbose
	# Remove unneeded files
	cd debian/luminance-hdr/usr/share/doc/luminance-hdr/ && \
		rm -v AUTHORS LICENSE README.md Changelog

built-using-cmdline = dpkg-query \
	-f='$${source:Package} (= $${source:Version})' -W libeigen3-dev

override_dh_gencontrol:
	dh_gencontrol -- \
		-Vlibeigen3-dev:Built-Using='$(shell $(built-using-cmdline))'


%:
	dh $@
